// Chopper Object Source

#include <graphics.h>
#include <dos.h>
#include <alloc.h>
#include "chopper.h"

#define LEFT	1
#define CENTER	2
#define RIGHT	3
#define UP	4
#define DOWN	5

chopper::chopper(int origx,int origy)
{
 c=0;
 i=75;
 x=origx;
 y=origy;
 grounded=0;
 bomb=0;
 dir=CENTER;
 ptr=farmalloc(imagesize(x-20,y-15,x+20,y+15));
 getimage(x-20,y-15,x+20,y+15,ptr);
 draw();
}

chopper::~chopper()
{
 farfree(ptr);
}

void chopper::move(int mdir)
{
 switch(mdir)
 {
  case UP:
   if((y>15)&&(!grounded))
   {
    dir=CENTER;
    putimage(x-20,y-15,ptr,COPY_PUT);
    y-=4;
    getimage(x-20,y-15,x+20,y+15,ptr);
    draw();
   }
   break;
  case DOWN:
   if((y<(getmaxy()*0.75)-10)&&(!grounded))
   {
    dir=CENTER;
    putimage(x-20,y-15,ptr,COPY_PUT);
    y+=4;
    getimage(x-20,y-15,x+20,y+15,ptr);
    if(!(y<(getmaxy()*0.75)-10))
    {
     dir=LEFT;
     draw();
    }
    else
     draw();
   }
   break;
  case LEFT:
   if((!grounded)&&(x>30))
   {
    dir=LEFT;
    putimage(x-20,y-15,ptr,COPY_PUT);
    x-=10;
    getimage(x-20,y-15,x+20,y+15,ptr);
    draw();
   }
   break;
  case RIGHT:
   if((!grounded)&&(x<(getmaxx()-30)))
   {
    dir=RIGHT;
    putimage(x-20,y-15,ptr,COPY_PUT);
    x+=10;
    getimage(x-20,y-15,x+20,y+15,ptr);
    draw();
   }
   break;
 }
}

void chopper::run()
{
 int i,j;
  if(!grounded)
  {
   if(c==0)
   {
    setcolor(15);
    line(x-10,y-5,x,y-5);
    setcolor(7);
    line(x,y-5,x+10,y-5);
    c=1;
   }
   else if(c==1)
   {
    setcolor(8);
    line(x-10,y-5,x+10,y-5);
    c=2;
   }
   else if(c==2)
   {
    setcolor(7);
    line(x-10,y-5,x,y-5);
    setcolor(15);
    line(x,y-5,x+10,y-5);
    c=0;
   }
   if(y<(getmaxy()*0.75)-10)
   {
    i=0;
    sound(40);
    delay((y/4)+5);
    sound(20);
    delay((y/2)+8);
   }
   else if(i==0)
    i=75;
   if(i!=0)
   {
    sound(40);
    delay(i/2);
    nosound();
    sound(20);
    delay(i/2);
    nosound();
    delay(i);
    i++;
   }
   if(i>400) i=400;
   nosound();
  }
 if(bomb)
 {
  putimage(bx-5,by-5,bptr,COPY_PUT);
  by++;
  getimage(bx-5,by-5,bx+5,by+5,bptr);
  drawBomb();
  if(by>=(getmaxy()*0.75))
  {
   bomb=0;
   setcolor(RED);
   for(j=0;j<=20;j++)
   { circle(bx,by,j); delay(10); }
   setcolor(CYAN);
   for(j=20;j>=0;j--)
   { circle(bx,by,j); delay(10); }
  }
 }
}

void chopper::status(s_chopper *data)
{
 data->x=x;
 data->y=y;
 data->grounded=grounded;
 data->bomb=bomb;
}

void chopper::draw()
{
 int i,j;
 if(dir==LEFT)
 {
  setcolor(7);
  setfillstyle(SOLID_FILL,7);
  fillellipse(x,y,8,3);
  setcolor(0);
  line((x-8),(y-1),(x-1),(y-1));
  line((x-7),(y-1)-1,(x-1),(y-1)-1);
  line((x-5),(y-1)-2,(x-1),(y-1)-2);
  setcolor(7);
  for(i=(y-1);i<=(y+1);i++)
   line((x+8),i,(x+20),i);
  setcolor(15);
  line((x-10),(y-5),(x+10),(y-5));
  putpixel(x,(y-4),8);
  setfillstyle(SOLID_FILL,7); setcolor(7);
  bar((x+17),(y+1),(x+20),(y-4));
  setcolor(0);
  line((x-6),(y+4),(x+10),(y+4));
 }
 else if(dir==RIGHT)
 {
  setcolor(7);
  setfillstyle(SOLID_FILL,7);
  fillellipse(x,y,8,3);
  setcolor(0);
  line((x+7),(y-1),(x+1),(y-1));
  line((x+6),(y-1)-1,(x+1),(y-1)-1);
  line((x+4),(y-1)-2,(x+1),(y-1)-2);
  setcolor(7);
  for(i=(y-1);i<=(y+1);i++)
   line((x-8),i,(x-20),i);
  setcolor(15);
  line((x-10),(y-5),(x+10),(y-5));
  putpixel(x,(y-4),8);
  setfillstyle(SOLID_FILL,7); setcolor(7);
  bar((x-17),(y+1),(x-20),(y-4));
  setcolor(0);
  line((x+6),(y+4),(x-10),(y+4));
 }
 else if(dir==CENTER)
 {
  setcolor(7);
  setfillstyle(SOLID_FILL,7);
  fillellipse(x,y,8,3);
  setcolor(0);
  setfillstyle(SOLID_FILL,0);
  fillellipse(x,y-2,6,1);
  setcolor(15);
  line(x-10,y-5,x+10,y-5);
  putpixel(x,y-4,8);
  setcolor(0);
  line(x-4,y+4,x-4,y+4);
  line(x+4,y+4,x+4,y+4);
 }
}

void chopper::drawBomb()
{
 setcolor(DARKGRAY);
 setfillstyle(SOLID_FILL,LIGHTGRAY);
 fillellipse(bx,by,2,2);
 line(bx-2,by-3,bx+2,by-3);
}

void chopper::dropBomb()
{
 bx=x;
 by=y+8;
 bomb=1;
 bptr=farmalloc(imagesize(bx-5,by-5,bx+5,by+5));
 getimage(bx-5,by-5,bx+5,by+5,bptr);
}
